/***************************************************************************
 *   Authors:                                                              *
 *   - Nicolas Brodu                                                       *
 *                                                                         *
 *   Copyrights:                                                           *
 *   - Nicolas Brodu (some code taken from the drrn2 project)              *
 *   - INRIA (modifications/diffs in SVN)                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
using namespace std;

int main(int argc, char** argv) {

    if (argc<3) {
        cout << "Arguments needed: input_file output_file" << endl;
        return 0;
    }

    ifstream inputfile(argv[1]);
    if (!inputfile) {
        cout << "Cannot read input file: " << argv[1] << endl;
        return 0;
    }

    ofstream outputfile(argv[2]);
    if (!outputfile) {
        cout << "Cannot write to output file: " << argv[2] << endl;
        return 0;
    }

    vector<double> currentValues;
    string line; double value;



// TODO: make printing NaN optional



    while (inputfile && !inputfile.eof()) {
        getline(inputfile, line);
        if (line.empty()) continue;
        stringstream linereader(line);
        if (currentValues.empty()) {
            while (linereader >> value) {
                if (!currentValues.empty()) outputfile << " ";
                outputfile << "NaN";
                currentValues.push_back(value);
            }
            outputfile << endl;
        } else {
            vector<double>::iterator it = currentValues.begin();
            vector<double>::iterator eit = currentValues.end();
            while (linereader >> value) {
                if (it==eit) break;
                if (it!=currentValues.begin()) outputfile << " ";
                outputfile << (value - *it);
                *it++ = value;
            }
            outputfile << endl;
        }
    }

    inputfile.close();
    outputfile.close();
}
